<script setup lang="ts">
import type { VForm } from 'vuetify/components'
import { ref, nextTick, provide } from 'vue'
import NavigationDrawer from '@/components/NavigationDrawer.vue'
import { useEmp } from '@/stores/employee'
import { useAuthStore } from '@/stores/auth'
import type { User } from '@/types/User'

const employeeStore = useEmp()
const authStore = useAuthStore()
const editedEmp = ref<User>(JSON.parse(JSON.stringify(authStore.currentUser)))
let editedIndex = -1
const emps = ref<User[]>([])
emps.value = authStore.users
const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)
let lastestId = 1
let latestId = 1
emps.value.forEach((employee) => {
  if (employee.id > lastestId) {
    latestId = employee.id
  }
})
const user1: User[] = authStore.users
lastestId = lastestId + 1
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedEmp.value = Object.assign({}, authStore.currentUser)
  })
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedEmp.value = Object.assign({}, authStore.currentUser)
    editedIndex = -1
  })
}
provide('userDialog', authStore.users)
async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(emps.value[editedIndex], editedEmp.value)
  } else {
    editedEmp.value.id = lastestId++
    emps.value.push(editedEmp.value)
  }
  closeDialog()
}
function deleteItemConfirm() {
  emps.value.splice(editedIndex, 1)
  closeDelete()
}

function editItem(item: User) {
  editedIndex = emps.value.indexOf(item)
  editedEmp.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: User) {
  editedIndex = emps.value.indexOf(item)
  editedEmp.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
</script>

<template>
  <div>
    <v-toolbar flat>
      <v-toolbar-title>Employee</v-toolbar-title>
      <v-divider class="mx-4" inset vertical></v-divider>
      <v-spacer></v-spacer>
      <v-row justify="center">
        <v-dialog v-model="dialog" persistent width="500">
          <template v-slot:activator="{ props }">
            <v-btn v-bind="props" style="background-color: #c7a17a" color="white">
              Add Employee
            </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5">Add Employee</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="6">
                      <v-text-field
                        v-model="editedEmp.fullname"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Fullname"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12" md="6">
                      <v-text-field
                        v-model="editedEmp.email"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Email"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12" md="12">
                      <v-text-field
                        v-model="editedEmp.username"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Username"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12" md="12">
                      <v-text-field
                        v-model="editedEmp.password"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Password"
                      ></v-text-field>
                      <v-file-input
                        label="File input"
                        variant="filled"
                        prepend-icon="mdi-camera"
                      ></v-file-input>
                    </v-col>
                    <v-col cols="12" sm="12" md="4">
                      <v-select
                        label="Gender"
                        :items="['male', 'female', 'others']"
                        v-model="editedEmp.gender"
                      ></v-select>
                    </v-col>
                    <!-- <v-col cols="12" sm="12" md="4">
                    <v-select label="Role" :items="['admin', 'user']" v-model="editedEmp.roles"></v-select>
                    </v-col> -->
                  </v-row>
                </v-container>
              </v-form>
              <small>*indicates required field</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-icon size="small" class="me-2" @click="editItem(editedEmp)">mdi-pencil</v-icon>
              <v-icon size="small" @click="deleteItem(editedEmp)">mdi-delete</v-icon>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </v-toolbar>
    <!-- <template v-slot:item="{ item }">
    <v-icon size="small" class="me-2" @click="editItem(item)">
        mdi-pencil
    </v-icon>
    <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
</template> -->
  </div>
  <!-- <v-col cols="12" md="6"
        ><v-sheet min-width="300" max-width="600" height="670" elevation="6">
          <v-tabs v-model="tab" color="deep-purple-accent-4" align-tabs="center">
            <v-tab :value="1">Drinks</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <UserList :users="user1" @selected-user="selected"></UserList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col> -->
  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
  <v-row>
    <v-col cols="12" sm="4" v-for="(employee, index) in emps" :key="index">
      <v-card class="mx-4 my-12" max-width="374">
        <v-img cover height="280" src="/src/assets/chocolate.png"></v-img>
        <v-card-item>
          <v-card-title>{{ employee.fullname }}</v-card-title>
        </v-card-item>
        <v-card-text>
          <v-divider class="mx-4 mb-1"></v-divider>
          <div class="my-4 text-subtitle-1">{{ employee.email }}</div>
          <div class="my-4 text-subtitle-1">{{ employee.gender }}</div>
          <div class="my-4 text-subtitle-1">{{ employee.roles.join(', ') }}</div>
          <div>ใส่ข้อมูล</div>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
            <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col cols="12" sm="4" v-for="(employee, index) in emps" :key="index">
      <v-card class="mx-4 my-12" max-width="374">
        <v-img cover height="280" src="/src/assets/chocolate.png"></v-img>
        <v-card-item>
          <v-card-title>{{ employee.fullname }}</v-card-title>
        </v-card-item>
        <v-card-text>
          <v-divider class="mx-4 mb-1"></v-divider>
          <div class="my-4 text-subtitle-1">{{ employee.email }}</div>
          <div class="my-4 text-subtitle-1">{{ employee.gender }}</div>
          <div class="my-4 text-subtitle-1">{{ employee.roles.join(', ') }}</div>
          <div>ใส่ข้อมูล</div>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
            <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col cols="12" sm="4" v-for="(employee, index) in emps" :key="index">
      <v-card class="mx-4 my-12" max-width="374">
        <v-img cover height="280" src="/src/assets/chocolate.png"></v-img>
        <v-card-item>
          <v-card-title>{{ employee.fullname }}</v-card-title>
        </v-card-item>
        <v-card-text>
          <v-divider class="mx-4 mb-1"></v-divider>
          <div class="my-4 text-subtitle-1">{{ employee.email }}</div>
          <div class="my-4 text-subtitle-1">{{ employee.gender }}</div>
          <div class="my-4 text-subtitle-1">{{ employee.roles.join(', ') }}</div>
          <div>ใส่ข้อมูล</div>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
            <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>
